#include  <errno.h>
#include  <sys/types.h>
#include  <sys/ipc.h>
#include  <sys/msg.h>
#include  <sys/sem.h>
#include  <sys/shm.h>
#include  <signal.h>

#define PERM  0666     // prawa dostepu
#define KLUCZ_KOM   (key_t)1231

//---- struktura dla komunikatow ----
      
struct m_komunikat {
  long typ;
  char z1;
}; 
 

 int main(int argc, char *argv[]) {
 
  int kom, kon, i, ik, czas; 
  struct m_komunikat msg; 
  if (argc<3) {
    printf("\n Brak argumentow :  znak[k=koniec], ilosc komunikatow , odstep czasu\n\n");
    exit(1);
  }   
  if ((kom=msgget(KLUCZ_KOM, 0))==-1) {
    perror("\n     K.msgget error  ");
    exit(-1);
  }
     
  msg.z1=*argv[1];        // znak  
  if (msg.z1=='k') {
    msg.typ=1;
    if  ((msgsnd(kom, &msg, sizeof(msg),0)) == -1) {
       perror("\n     K.Awaria serwera  ");
       exit(-1);
    }    
  } else {
    msg.typ=2; 
    ik=atoi(argv[2]);      // ilosc komunikatow
    czas=atoi(argv[3]);    // odstep czasu
    for (i=1;i<=ik;i++) {
      sleep(czas);
      if ((msgsnd(kom, &msg, sizeof(msg),0)) == -1) {
         perror("\n    K.Awaria serwera  ");
         exit(-1);
      }
          
    }
  }
  printf("\n\nKoniec pracy Klienta %c\n\n", msg.z1);
  exit (0); 
}

