#include  <unistd.h>
#include  <stdlib.h>
#include  <stdio.h>
#include  <sys/types.h>
#include  <sys/ipc.h>
#include  <sys/msg.h>
#include  <signal.h>
#include  <ncurses.h>

#define PERM  0660     // prawa dostepu
#define KLUCZ_KOM   (key_t)1231

//---- struktura dla komunikatow ----
      
struct m_komunikat {
  long typ;
  char z1;
}; 

 int kom, kon; 

void koniec() {
  msgctl(kom, IPC_RMID, 0);
  
  curs_set(1);
  clear();
  refresh();
  endwin();

  printf("\n      Ctrl_C Serwera\n");
  exit(0);
} 

 int main(void) {
 
 
  struct m_komunikat msg;
  
  signal(SIGINT, koniec); 
  
  initscr();
  curs_set(0);
  start_color();
  clear();

  
  
  if ((kom=msgget(KLUCZ_KOM, PERM | IPC_CREAT))==-1) {
     perror("\n     S.msgget error\n");
     exit(-1);
  }   
  move(1,10); 
  printw("%s","               Test kolejki komunikatow\n\n");  
  refresh();
  move(3,1);
  kon=1;
  while(kon){ 
    if ((msgrcv(kom,&msg,sizeof(msg),0 ,0))==-1) {
      perror("\n    S.msgrcv error  ");
      kon=0; 
    } else {
      switch(msg.typ) {
        case 1:
            kon=0;
            break;
        case 2:
            printw("%c",msg.z1);
	    refresh();  
            break;
        
        default:
            break; 
      }
    }    
  } 
 
 
  sleep(2);
   
  msgctl(kom, IPC_RMID, 0);
  curs_set(1);
  clear();
  refresh();
  endwin();

  printf("\nKoniec pracy Serwera\n");
  return (0); 
}

